/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
  endcopyright */

/*
 * CirioNubPrivate.h
 *
 * Demers, November 2, 1989 10:11:59 am PST
 *
 * Private definitions for CirioNub RPC Runtime.
 */

#ifndef _CIRIO_NUB_PRIVATE_
#define _CIRIO_NUB_PRIVATE_

#include "xr/ThreadsSlaveIOP.h"
#include "xr/CirioNubProtocol.h"
#include "xr/CirioNubInstall.h"

#include <sys/types.h>
#include <netinet/in.h>


typedef struct CirioNubProcEntry {
    struct CirioNubProcEntry *cnpe_next;
    int cnpe_procID;
    CirioNubProc cnpe_proc;
    char *cnpe_clientData;
};

typedef struct CirioNubDataRep {
    int cnd_installed;
    XR_Slave cnd_slave;
    int cnd_listenerPort;
    int cnd_listenerFD;
    int cnd_rpcFD;
    void (*cnd_initProc)(/* unsigned clientData */);
    unsigned cnd_initClientData;
    int cnd_numHdrs;
    int *cnd_callBuf;
    int cnd_callBufBytes;
    struct CirioNubProcEntry *cnd_procEntries[1];
} * CirioNubData;

#endif /* _CIRIO_NUB_PRIVATE_ */
